unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, pngimage, dihavBtn, jpeg, ExtCtrls, StdCtrls, ShellApi, ActnList,
  ImgList, XPMan;

type
  TForm1 = class(TForm)
    Group2Btn3: TdihavButton;
    Group1Btn1: TdihavButton;
    OKBtn: TdihavButton;
    SimpleBtn2: TdihavButton;
    Group1Btn2: TdihavButton;
    CancelBtn: TdihavButton;
    Group1Btn3: TdihavButton;
    SimpleBtn1: TdihavButton;
    Group2Btn2: TdihavButton;
    Group2Btn1: TdihavButton;
    BackImg: TImage;
    EnCheckBox: TCheckBox;
    SimpleBtn3: TdihavButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    dihavButton1: TdihavButton;
    ImageList1: TImageList;
    ActionList1: TActionList;
    Action1: TAction;
    Button1: TButton;
    dihavButton2: TdihavButton;
    Shape1: TShape;
    Label8: TLabel;
    XPManifest1: TXPManifest;
    Label9: TLabel;
    procedure Group1Btn1CustomBackground(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect);
    procedure Group2Btn2StateChanged(Sender: TObject;
      AOldState: TdihavButtonState);
    procedure EnCheckBoxClick(Sender: TObject);
    procedure SimpleBtn2CustomMapping(Sender: TObject;
      AEffect: TdihavButtonEffect; U, V: Single; var X, Y: Single);
    procedure SimpleBtn3CustomColoring(Sender: TObject;
      AEffect: TdihavButtonEffect; var R, G, B, A: Byte);
    procedure Group1Btn1CustomMapping(Sender: TObject;
      AEffect: TdihavButtonEffect; U, V: Single; var X, Y: Single);
    procedure FormCreate(Sender: TObject);
    procedure Group2Btn1CustomAnimationScript(Sender: TObject;
      AEffect: TdihavButtonEffect; ALineNumber: Integer; AText: string);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Action1Execute(Sender: TObject);
begin
ShowMessage('Action executed.');
end;

procedure TForm1.CancelBtnClick(Sender: TObject);
begin
ShowMessage('Cancel clicked.');
end;

procedure TForm1.EnCheckBoxClick(Sender: TObject);
var k: Integer;
begin
for k := 0 to ControlCount - 1 do
  if (Controls[k] is TdihavButton) then
    (Controls[k] as TdihavButton).Enabled := EnCheckBox.Checked;
end;

procedure TForm1.Group2Btn1CustomAnimationScript(Sender: TObject;
  AEffect: TdihavButtonEffect; ALineNumber: Integer; AText: string);
begin
if (AText = 'CustomAnimation1') then
  begin
  AEffect.WidthPercentage := 100 + Random(30);
  AEffect.HeightPercentage := 100 + Random(30);
  end;
if (AText = 'CustomAnimation2') then
  begin
  AEffect.WidthPercentage := 100 - Random(30);
  AEffect.HeightPercentage := 100 - Random(30);
  end;
if (AText = 'CustomAnimation3') then
  begin
  AEffect.AnimateFromLastState := False;
  AEffect.RotationAngle := 0;
  AEffect.AnimationDuration := 0;
  AEffect.ApplyChangesNow := True;
  AEffect.AnimateFromLastState := True;
  end;
end;

procedure TForm1.SimpleBtn3CustomColoring(Sender: TObject;
  AEffect: TdihavButtonEffect; var R, G, B, A: Byte);
var c, d: Byte;
begin
c := Round(G * B * A / 65025);
d := Round(R * B * A / 65025);
B := Round(G * R * A / 65025);
G := c;
R := d;
end;

procedure TForm1.Group1Btn1CustomBackground(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect);
var B: TdihavButton;
begin
B := Sender as TdihavButton;
ACanvas.CopyRect(ARect, BackImg.Picture.Bitmap.Canvas, Bounds(B.Left - BackImg.Left, B.Top - BackImg.Top, B.Width, B.Height));
end;

procedure TForm1.Group1Btn1CustomMapping(Sender: TObject;
  AEffect: TdihavButtonEffect; U, V: Single; var X, Y: Single);
begin
X := -U;
Y := V;
end;

procedure TForm1.SimpleBtn2CustomMapping(Sender: TObject;
  AEffect: TdihavButtonEffect; U, V: Single; var X, Y: Single);
begin
if (U = 0) then X := U else X := U * U * U / 34 / Abs(U);
if (V = 0) then Y := V else Y := V * V * V / 34 / Abs(V);
end;

procedure TForm1.Group2Btn2StateChanged(Sender: TObject;
  AOldState: TdihavButtonState);
begin
if (bsDown in Group2Btn2.ButtonState) then
  Group2Btn2.Caption := 'OK'
else
  Group2Btn2.Caption := '';
end;

procedure TForm1.Label6Click(Sender: TObject);
begin
ShellExecute(Handle, '', 'http://www.dihav.com/', '', '', SW_SHOW);
end;

procedure TForm1.OKBtnClick(Sender: TObject);
begin
ShowMessage('OK clicked.');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Group1Btn1.EffectFocused.Assign(Group1Btn1.EffectOver);
CancelBtn.AssignEffectsFromButton(OKBtn);
dihavButton1.Caption := '';
dihavButton1.AssignEffectsFromButton(OKBtn);
dihavButton2.AssignEffectsFromButton(OKBtn);
Label7.Caption := 'This button is able to'#13'get images also'#13'from ImageList and'#13'linked Action.';
end;

end.
